datablock AudioProfile(AmmoLockerOpenSound)
{
	filename = "./lockeropen.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(AmmoLockerCloseSound)
{
	filename = "./lockerclosea.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(AmmoCrateSound)
{
	filename = "./AmmoCrateSound.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock ItemData(RAmmoCrateItem)
{
	category = "Item";  // Mission editor category
	//className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./RotCoAmmoCrate2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "";
	iconName = "";
	doColorShift = false;
	isSwepAmmoCrate = 1;

	 // Dynamic properties defined by the scripts
	image = "";
	canDrop = true;
};
datablock fxDTSBrickData (BrickAmmoCrateData)
{
	brickFile = "./AmmoCrateBrick.blb";
	category = "Special";
	subCategory = "Interactive";
	uiName = "Ammo Crate";
	iconName = "add-ons/Brick_Sweps_AmmoCrate/Icon_AmmoCrate";
	indestructable = 1;
	isSwepAmmoCrate = 1;
};

function BrickAmmoCrateData::onloadPlant(%data, %brick, %a, %b)
	{
	BrickAmmoCrateData::onPlant(%data, %brick, %a, %b);
	}

function BrickAmmoCrateData::onPlant(%data, %brick, %a, %b)
{
  %brick.setrendering(0);
  %attach = new Item()
	{
		datablock = "RAmmoCrateItem";
		static = 1;
	};
	%attach.spawnbrick = %brick;
    %attach.settransform(vectoradd(%brick.gettransform(),"0 0 -0.4") SPC getwords(%brick.gettransform(),3,6));
    %brick.attachment = %attach;

    %brick.AmmoSupplyCount = 0;
}

function BrickAmmoCrateData::onRemove(%data, %brick)
{
   if(isObject(%brick.attachment))
	{
      %brick.attachment.delete();
      %brick.attachment.Cancel(AmmoCrateAnim);
      %brick.attachment.Cancel(AmmoEvalcrashes);
	}
      parent::OnRemove(%data,%brick);
}


function BrickAmmoCrateData::onDeath(%data, %brick)
{
   if(isObject(%brick.attachment))
	{
      %brick.attachment.delete();
	}
      parent::OnDeath(%data,%brick);
}

function AmmoCrateAnim(%obj,%oc)
{
	if(%oc == 1)
	{
		%obj.playaudio(2,AmmoLockerOpenSound);
		%obj.playthread(1,open);
		%obj.isopen = 1;
		
	}
	if(%oc == 0)
	{
		%obj.playthread(1,close);
		cancel(%obj.slowd);
		%obj.isopen = 0;
		%obj.isshutting = 1;
		%obj.slowd = schedule(600,0,AmmoEvalcrashes,%obj);
		%obj.playaudio(2,AmmoLockerCloseSound);
	}
}

function AmmoEvalCrashes(%obj)
{
	%obj.isshutting= 0;
}

package SwepCrateColFunctions
{
function Armor::onCollision(%this,%obj,%col,%a,%b,%c,%d)
{
if(%col.getdatablock().getname() $= "RAmmoCrateItem" && %obj.hType !$= "Zombie" && %obj.getstate() !$= "Dead")
		{
			%ammoType = %obj.getmountedimage(0).item.sAmmoType;
			%ammo = %obj.getmountedimage(0).item.sAmmo;
			%max = swolammo_getMax(%ammoType);
	
	if($SwepCrate::Supplies && %obj.sReserve[%ammoType] < %max && %col.isshutting !$= 1 && %col.lasttouch+$SwepCrate::AcquireDelay < getsimtime() && %col.AmmoSupplyCount < $SwepCrate::SupplyAmount) //If supplies is enabled
		{
			%obj.playthread(2, plant);
            serverPlay3D(ammocratesound,%obj.getPosition());
            serverPlay3D(pickupAmmo @ getRandom(1,2) @ Sound,%col.getPosition());
            %col.lasttouch = getsimtime();
            %col.AmmoSupplyCount += 1;
            %obj.client.centerprint("<just:center><font:impact:40>\c6Supplies:" @ "<br>\c2"SPC $SwepCrate::SupplyAmount-%col.AmmoSupplyCount,1);
            	%obj.sReserve[%ammoType] = %max;
			            sAmmo_display(%obj);

		             	   if(%col.isopen == 0)
						{
						AmmoCrateAnim(%col,1);
						}
					cancel(%col.closedoor);
					%col.closedoor = schedule(600,0,AmmoCrateAnim,%col,0);

   		}

	if(!$SwepCrate::Supplies && %obj.sReserve[%ammoType] < %max && %col.isshutting !$= 1 && %col.lasttouch+$SwepCrate::AcquireDelay < getsimtime()) //If supplies is disabled
		{
			%obj.playthread(2, plant);
           	serverPlay3D(ammocratesound,%obj.getPosition());
          	serverPlay3D(pickupAmmo @ getRandom(1,2) @ Sound,%col.getPosition());
            %col.lasttouch = getsimtime();

            	%obj.sReserve[%ammoType] = %max;
			            sAmmo_display(%obj);
		
		             	   if(%col.isopen == 0)
						{
						AmmoCrateAnim(%col,1);
						}
					cancel(%col.closedoor);
					%col.closedoor = schedule(600,0,AmmoCrateAnim,%col,0);      	
        }

        		if($SwepCrate::Supplies && %col.AmmoSupplyCount == $SwepCrate::SupplyAmount && %ammotype) //Only works if supplies is enabled
					{
				%obj.client.centerprint("<just:center><font:impact:40>\c6Supplies:" @ "<br>\c0"SPC $SwepCrate::SupplyAmount-%col.AmmoSupplyCount,1);
        			}
			return;
		}
		Parent::onCollision(%this,%obj,%col,%a,%b,%c,%d);
}

//function MiniGameSO::reset(%mini, %client)//When the minigame resets, the mission cleanup will search for a brick that has the AmmoSupplyCount variable and set it to 0.
//{
//if($SwepCrate::ResetOnMini)
//{
//	for(%i=0; %i < MissionCleanup.getCount(); %i++)
//		{
//  		%obj = MissionCleanup.getObject(%i);
//    		if(%obj.getClassName() $= "Item" && %obj.getdatablock().getname() $= "RAmmoCrateItem")
//    		{
//    		%obj.AmmoSupplyCount = 0;
//    		}
//		}
//}
//	Parent::reset(%mini, %client);
//}

};
activatepackage(SwepCrateColFunctions);