%error = ForceRequiredAddOn("Weapon_Sweps");

if(%error == $Error::AddOn_Disabled)
{
   BrickAmmoCrateData.uiName = "";
}

if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Brick_Sweps_AmmoCrate - required add-on Weapon_Sweps not found");
}
else
{
   exec("./brick_sweps_ammocrate.cs"); 
}

if(isFunction(registerPreferenceAddon))//Function for BLG preferences
{
	registerPreferenceAddon("Brick_Sweps_AmmoCrate", "SWep Ammo Crate", "box");

	new ScriptObject(Preference)
	{
		className      = "SwepAmmoCrate";

		addon          = "Brick_Sweps_AmmoCrate";
		category       = "Swep Ammo Crate";
		title          = "Limited supplies";

		type           = "bool";
		params         = "";

		variable       = "$SwepCrate::Supplies";

		defaultValue   = "1";

		updateCallback = "SwepAmmoCrate_UpdateMethod";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};


			new ScriptObject(Preference)
	{
		className      = "SwepAmmoCrate";

		addon          = "Brick_Sweps_AmmoCrate";
		category       = "Swep Ammo Crate";
		title          = "Supply ammount";

		type           = "num";
		params         = "1 40 0";

		variable       = "$SwepCrate::SupplyAmount";

		defaultValue   = "20";

		updateCallback = "SwepAmmoCrate_UpdateMethod";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};

				new ScriptObject(Preference)
	{
		className      = "SwepAmmoCrate";

		addon          = "Brick_Sweps_AmmoCrate";
		category       = "Swep Ammo Crate";
		title          = "Acquire delay (ms)";

		type           = "num";
		params         = "50 750 0";

		variable       = "$SwepCrate::AcquireDelay";

		defaultValue   = "500";

		updateCallback = "SwepAmmoCrate_UpdateMethod";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};
}

else	//If BLG isn't installed
{
	$SwepCrate::Supplies = 1;
	$SwepCrate::SupplyAmount = 20;
	$SwepCrate::AcquireDelay = 500;
}

registerOutputEvent(fxDTSBrick, "resetCrateAmmo");

function fxDTSbrick::ResupplyCrateAmmo(%brick)
{
    if(%brick.attachment.getdatablock().getname() $= "RAmmoCrateItem")//Find if a brick's attachment is RAmmoCrateItem
    {
       %brick.attachment.AmmoSupplyCount = 0;//It seems counterintuitive to set it to 0, but that's how it works.
    }
}